Handle interrupts within suspend.
--- diff/drivers/md/dm.c	2004-03-01 15:42:47.000000000 +0000
+++ source/drivers/md/dm.c	2004-03-01 15:43:26.000000000 +0000
@@ -873,7 +873,7 @@ int dm_suspend(struct mapped_device *md)
 	while (1) {
 		set_current_state(TASK_INTERRUPTIBLE);
 
-		if (!atomic_read(&md->pending))
+		if (!atomic_read(&md->pending) || signal_pending(current))
 			break;
 
 		io_schedule();
@@ -882,6 +882,14 @@ int dm_suspend(struct mapped_device *md)
 
 	down_write(&md->lock);
 	remove_wait_queue(&md->wait, &wait);
+
+	/* were we interrupted ? */
+	if (atomic_read(&md->pending)) {
+		clear_bit(DMF_BLOCK_IO, &md->flags);
+		up_write(&md->lock);
+		return -EINTR;
+	}
+
 	set_bit(DMF_SUSPENDED, &md->flags);
 	if (md->map)
 		dm_table_suspend_targets(md->map);
